package me.Demon.DemonPlayerMail.Api;

import me.Demon.DemonPlayerMail.Main;
import org.bukkit.inventory.ItemStack;

public abstract class DMailAPI {

    //发送物品到玩家邮箱中
    public static void GiveItem(String playName, ItemStack item) {
        //获取物品数量
        int amount = item.getAmount();
        //设置邮箱物品数量
        addMailAmount(playName, amount);
        //获取物品key标识
        int keyId = Main.getRandomInt(80000, 10000);
        //设置物品到邮箱
        Main.mailDataG.set("MailData." + playName + "." + keyId, item);
        //保存邮箱设置
        Main.saveMailDataConfig();
        //保存邮箱日志
        Main.SaveLogAndSendLog(playName, item, "新增");
    }

    //获取玩家邮箱有多少个物品
    public static int getMailAmount(String playName) {
        return Main.mailDataG.getInt("MailData." + playName + ".amount");
    }

    //增加玩家邮箱物品数量
    public static void addMailAmount(String playName, int amount) {
        int amountPro = getMailAmount(playName);
        Main.mailDataG.set("MailData." + playName + ".amount", (amountPro + amount));
        Main.saveMailDataConfig();
    }

    //设置玩家邮箱物品数量
    public static void setMailAmount(String playName, int amount) {
        Main.mailDataG.set("MailData." + playName + ".amount", amount);
        Main.saveMailDataConfig();
    }

    //清空玩家的邮箱数据
    public static void resetMailData(String playName) {
        Main.mailDataG.set("MailData." + playName, null);
    }

}