package me.Demon.DemonPlayerMail;

import me.Demon.DemonPlayerMail.Listener.JoinEvant;
import me.Demon.DemonPlayerMail.Listener.meMail;
import me.Demon.DemonPlayerMail.Listener.toMail;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.*;

public class Main extends JavaPlugin implements Listener {

    public static Main plugin;
    public static String prefix = "§7[§a§l邮箱§7] §f";
    public static String serverName = "主城";
    public static File Datafile = new File("plugins/DemonPlayerMail", "MailData.yml");
    public static FileConfiguration mailDataG = YamlConfiguration.loadConfiguration(Datafile);

    public static void saveMailDataConfig() {
        try {
            mailDataG.save(Datafile);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void onEnable() {
        plugin = this;
        saveDefaultConfig();
        serverName = getConfig().getString("ServerName");
        Bukkit.getConsoleSender().sendMessage("§b[玩家邮箱] §a插件成功载入Server！");
        Bukkit.getConsoleSender().sendMessage("§b[玩家邮箱] §a妖魂QQ:1763917516");
        Bukkit.getPluginManager().registerEvents(this, this);
        Bukkit.getServer().getPluginManager().registerEvents(new meMail(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new toMail(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new JoinEvant(), plugin);
    }

    public void onDisable() {
        Bukkit.getConsoleSender().sendMessage("§b[DemonPlayerMail] §c插件已正常关闭！");
    }

    public boolean onCommand(CommandSender sender, Command cmd, String Command, String[] args) {
        if (Command.equalsIgnoreCase("dpmail")) {
            if (args.length == 2 && args[0].equalsIgnoreCase("to") && sender.isOp()) {
                if (sender instanceof Player) {
                    String playName = args[1];
                    toMail.OpenGui((Player) sender, playName);
                }
            } else if (args.length == 1 && args[0].equalsIgnoreCase("open")) {
                if (sender instanceof Player) {
                    Player p = (Player) sender;
                    meMail.OpenGui(p);
                }
            } else if (args.length == 1 && args[0].equalsIgnoreCase("clearall")) {
                // 清理日志
                getConfig().set("MailDataLog", null);
                saveConfig();
                // 清理玩家邮箱物品操作
                int a = 0;
                FileConfiguration yml = Main.mailDataG;
                for (String playName : yml.getConfigurationSection("MailData").getKeys(false)) {
                    yml.set("MailData." + playName, null);
                    int size = yml.getConfigurationSection("MailData." + playName).getKeys(false).size();
                    if (size >= 2) {
                        a++;
                    }
                }
                Main.saveMailDataConfig();
                sender.sendMessage(prefix + "操作成功,清理物品[§e" + a + "§f]件.");
            } else {
                sender.sendMessage("");
                sender.sendMessage("§e------- ======= §6魂式系统邮箱 §e======= -------");
                sender.sendMessage("§2/dpmail open §f- §2打开邮箱");
                sender.sendMessage("§2/dpmail clearall §f- §2清理邮箱");
                sender.sendMessage("§2/dpmail to §e[玩家名] §f- §2发送物品");
                sender.sendMessage("§e------- ======= §6魂式系统邮箱 §e======= -------");
            }
        }
        return true;
    }

    public static String getTime(String format) {
        Date date = Calendar.getInstance().getTime();
        SimpleDateFormat datatime = new SimpleDateFormat(format);
        return datatime.format(date);
    }

    public static int getRandomInt(int max, int mix) {
        return new Random().nextInt(max) + mix;
    }

    public static boolean itemIsNull(ItemStack item) {
        return item == null || item.getType() == Material.AIR;
    }

    public static boolean itemIsLore(ItemStack item) {
        return item.getItemMeta().getLore() == null;
    }

    public static List<String> getPlayerLog(String time) {
        return Main.plugin.getConfig().getStringList("MailDataLog." + time);
    }

    public static void SaveLogAndSendLog(String playName, ItemStack item, String type) {
        List<String> list = new ArrayList<>();
        String time = getTime("yyyy-MM-dd");
        list.add("[日志] " + Main.getTime("HH:mm") + " 玩家 " + playName + " " + type + "物品 " + item.getItemMeta().getDisplayName() + " 数量:" + item.getAmount());
        list.addAll(Main.getPlayerLog(playName));
        Main.plugin.getConfig().set("MailDataLog." + time, list);
        Main.plugin.saveConfig();
    }
}
