package me.Demon.DemonPlayerMail.Listener;

import me.Demon.DemonPlayerMail.Api.DMailAPI;
import me.Demon.DemonPlayerMail.Main;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class meMail implements Listener {

    public static String inv_title = "§m§a§i§l§r玩家邮箱 - 收件箱[" + Main.serverName + "]";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (inv_title.equalsIgnoreCase(e.getView().getTitle())) {
            e.setCancelled(true);
            if (e.getRawSlot() == 40) {
                int amount = DMailAPI.getMailAmount(p.getName());
                if (amount < 1) {
                    p.sendMessage(Main.prefix + "你没有可签收的物品.");
                    p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
                    return;
                }
                YamlConfiguration yml = (YamlConfiguration) Main.mailDataG;
                for (String keyId : yml.getConfigurationSection("MailData." + p.getName()).getKeys(false)) {
                    if (!keyId.equalsIgnoreCase("amount")) {
                        ItemStack item = yml.getItemStack("MailData." + p.getName() + "." + keyId);
                        p.getInventory().addItem(item);
                        yml.set("MailData." + p.getName() + "." + keyId, null);
                        Main.SaveLogAndSendLog(p.getName(), item, "签收");
                    }
                }
                OpenGui(p);
                DMailAPI.setMailAmount(p.getName(), 0);
                Main.saveMailDataConfig();
                p.sendMessage(Main.prefix + "成功签收 §a" + amount + " §f样物品.");
                p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
            }
        }
    }

    public static void OpenGui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 45, inv_title);
        YamlConfiguration yml = (YamlConfiguration) Main.mailDataG;
        if (yml.getString("MailData." + p.getName()) != null) {
            for (String keyId : yml.getConfigurationSection("MailData." + p.getName()).getKeys(false)) {
                if (!keyId.equalsIgnoreCase("amount")) {
                    ItemStack item = yml.getItemStack("MailData." + p.getName() + "." + keyId);
                    inv.addItem(item);
                }
            }
        }
        for (int i = 36; i < 45; i++) {
            inv.setItem(i, glass());
        }
        inv.setItem(40, InfoItems());
        p.openInventory(inv);
        p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
    }


    public static ItemStack glass() {
        ItemStack item = new ItemStack(160, 1, (short) 15);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7[§a■□■§7]");
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack InfoItems() {
        ItemStack item = new ItemStack(Material.SLIME_BALL);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§a点击一键签收");
        List<String> lore = new ArrayList<>();
        lore.add("§e★§7点击将邮件物品全部收取");
        lore.add("§c★§7请检查背包空位是否充足");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
